import java.awt.Color;
import java.awt.Font;
import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.SwingConstants;

import object.ObjectFile;
import util.StringUtil;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

public class Frame extends javax.swing.JFrame {

	private static final long serialVersionUID = 1L;
	// Variables declaration - do not modify
	private javax.swing.JLabel jLabel1;
	private javax.swing.JLabel jLabel2;
	private javax.swing.JLabel jLabel4;
	private javax.swing.JLabel jLabel5;
	private javax.swing.JLabel jLabel6;
	private javax.swing.JButton jButton1;
	private javax.swing.JButton jButton2;
	private javax.swing.JButton jButton4;
	private javax.swing.JButton jButton5;
	private javax.swing.JTextField jTextField1;
	private javax.swing.JTextField jTextField2;
	// End of variables declaration

	private String path1;
	private String path2;

	public String getPath1() {
		return path1;
	}

	public String getPath2() {
		return path2;
	}

	/**
	 * Creates new form Frame
	 */
	public Frame() {
		path1 = "";
		path2 = "";
		initComponents(); 
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */

	// <editor-fold defaultstate="collapsed" desc="Generated Code">
	private void initComponents() {

		jLabel1 = new javax.swing.JLabel();
		jLabel2 = new javax.swing.JLabel();
		jTextField1 = new javax.swing.JTextField();
		jTextField2 = new javax.swing.JTextField();
		jButton1 = new javax.swing.JButton();
		jButton2 = new javax.swing.JButton();
		jLabel4 = new javax.swing.JLabel();
		jLabel5 = new javax.swing.JLabel();
		jLabel6 = new javax.swing.JLabel();
		jButton4 = new javax.swing.JButton();
		jButton5 = new javax.swing.JButton();

		setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
		setTitle("Advanced Encryption Standard");

		jLabel1.setText("Open File");
		jLabel2.setText("Open Key");
		jTextField1.setText("Plaintext path");
		jTextField2.setText("Key path");

		jButton1.setText("open");
		jButton1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton1ActionPerformed(evt);
			}
		});

		jButton2.setText("open");
		jButton2.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				jButton2ActionPerformed(evt);
			}
		});

		/**
		 * jButton3.setText("save"); jButton3.addActionListener(new
		 * java.awt.event.ActionListener() { public void
		 * actionPerformed(java.awt.event.ActionEvent evt) {
		 * jButton3ActionPerformed(evt); } });
		 */

		jLabel4.setText("AES With CTR Mode");
		jLabel4.setHorizontalAlignment(JLabel.CENTER);
		jLabel4.setFont(new Font("Arial", Font.BOLD, 24));
		jLabel4.setForeground(Color.blue);

		jButton4.setText("Encrypt");
		jButton4.setHorizontalAlignment(SwingConstants.RIGHT);
		jButton4.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				try {
					jButton4ActionPerformed(evt);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});

		jButton5.setText("Decrypt");
		jButton5.setHorizontalAlignment(SwingConstants.RIGHT);
		jButton5.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				try {
					jButton5ActionPerformed(evt);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(layout.createSequentialGroup().addGroup(layout
						.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(layout.createSequentialGroup().addGap(38, 38, 38).addGroup(layout
								.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
								.addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 320,
										javax.swing.GroupLayout.PREFERRED_SIZE)
								.addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 344,
										javax.swing.GroupLayout.PREFERRED_SIZE)
								.addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 344,
										javax.swing.GroupLayout.PREFERRED_SIZE)
								.addGroup(layout.createSequentialGroup()
										.addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
												.addComponent(jLabel1).addComponent(jLabel2))
										.addGap(18, 18, 18)
										.addGroup(layout
												.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
												.addComponent(jTextField2).addComponent(jTextField1))
										.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
										.addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
												.addComponent(jButton1).addComponent(jButton2)))))
						.addGroup(layout.createSequentialGroup().addGap(127, 127, 127).addComponent(jButton4)
								.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addComponent(
										jButton5)))
						.addContainerGap(26, Short.MAX_VALUE)));
		layout.setVerticalGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).addGroup(layout
				.createSequentialGroup().addContainerGap().addComponent(jLabel4)
				.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addComponent(jLabel5)
				.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).addComponent(jLabel6)
				.addGap(20, 20, 20)
				.addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(jLabel1)
						.addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE,
								javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
						.addComponent(jButton1))
				.addGap(37, 37, 37)
				.addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(jLabel2)
						.addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE,
								javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
						.addComponent(jButton2))
				.addGap(41, 41, 41).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE))
				.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
				.addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).addComponent(jButton4)
						.addComponent(jButton5))
				.addContainerGap(48, Short.MAX_VALUE)));

		pack();
	}// </editor-fold>

	private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		JFileChooser fileChooser = new JFileChooser();
		int returnVal = fileChooser.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fileChooser.getSelectedFile();
			try {
				// What to do with the file, e.g. display it in a TextArea
				jTextField1.setText(file.getAbsolutePath());
				path1 = jTextField1.getText();
			} catch (Exception ex) {
				System.out.println("Problem accessing file" + file.getAbsolutePath());
			}
		} else {
			System.out.println("File access cancelled by user.");
		}
	}

	private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		JFileChooser fileChooser = new JFileChooser();
		int returnVal = fileChooser.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fileChooser.getSelectedFile();
			try {
				// What to do with the file, e.g. display it in a TextArea
				jTextField2.setText(file.getAbsolutePath());
				path2 = jTextField2.getText();
			} catch (Exception ex) {
				System.out.println("Problem accessing file" + file.getAbsolutePath());
			}
		} else {
			System.out.println("File access cancelled by user.");
		}
	}

	/**
	 * private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) { //
	 * TODO add your handling code here: JFileChooser fileChooser = new
	 * JFileChooser(); int returnVal = fileChooser.showSaveDialog(this); if
	 * (returnVal == JFileChooser.APPROVE_OPTION) { File file =
	 * fileChooser.getSelectedFile(); try { // What to do with the file, e.g.
	 * display it in a TextArea jTextField3.setText(file.getAbsolutePath());
	 * path3 = jTextField3.getText(); } catch (Exception ex) {
	 * System.out.println("problem accessing file" + file.getAbsolutePath()); }
	 * } else { System.out.println("File access cancelled by user."); } }
	 */

	private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) throws Exception {
		// TODO add your handling code here:
		// Encryption
		ObjectFile file = new ObjectFile();
		file.setInputFile(new File(path1));
		file.setKeyFile(new File(path2));

		Path keyPath = Paths.get(file.getKeyFile().getAbsolutePath());
		String keyHex = Files.readAllLines(keyPath).get(0);
		byte[] keyBytes = null;
		Boolean isHex = true;
		
		if(keyHex.length() % 2 != 0){
			isHex = false;
		}else{
			keyBytes = StringUtil.hexStringToByteArray(keyHex);
		}
		
		if(keyHex.isEmpty()){
			isHex = false;
		}else if(!keyHex.isEmpty()){
			for(int i = 0; i < keyHex.length(); i++){
				if(Character.digit(keyHex.charAt(i), 16) == -1){
					isHex = false;
				}
			}
		}

		// Check the selected key
		if(isHex == false){
			JOptionPane.showMessageDialog(null, "Key is not in HEX format!");
		}else if (keyBytes.length == 16 || keyBytes.length == 24 || keyBytes.length == 32) {
			// Send the aes specification to Aes class
			String result = AES_CTR.startEncrypt(file);
			// System.out.println(result);

			JOptionPane.showMessageDialog(null,
					"Successfully Encrypt the plaintext. Your cipher text location at: " + result);
			// System.out.println(keyBytes.length + "byte");
		} else {
			System.out.println(keyBytes.length + "byte");
			JOptionPane.showMessageDialog(null, "Wrong key selected. Please select key with 128 or 192 or 256 bit.");
		}
	}

	private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) throws Exception {
		// TODO add your handling code here:
		// Decryption
		ObjectFile file = new ObjectFile();
		file.setInputFile(new File(path1));
		file.setKeyFile(new File(path2));
		
		Path keyPath = Paths.get(file.getKeyFile().getAbsolutePath());
		String keyHex = Files.readAllLines(keyPath).get(0);
		
		byte[] keyBytes = null;
		Boolean isHex = true;
		
		if(keyHex.length() % 2 != 0){
			isHex = false;
		}else{
			keyBytes = StringUtil.hexStringToByteArray(keyHex);
		}
		
		if(keyHex.isEmpty()){
			isHex = false;
		}else if(!keyHex.isEmpty()){
			for(int i = 0; i < keyHex.length(); i++){
				if(Character.digit(keyHex.charAt(i), 16) == -1){
					isHex = false;
				}
			}
		}

		// Check the selected key
		if(isHex == false){
			JOptionPane.showMessageDialog(null, "Key is not in HEX format!");
		}else if (keyBytes.length == 16 || keyBytes.length == 24 || keyBytes.length == 32) {
			// Send the aes specification to Aes class
			String result = AES_CTR.startDecrypt(file);
			JOptionPane.showMessageDialog(null,
					"Successfully Decrypt the ciphertext. Your decypted text location at: " + result);
		} else {
			System.out.println(keyBytes.length + "byte");
			JOptionPane.showMessageDialog(null, "Wrong key selected. Please select key with 128 or 192 or 256 bit.");
		}
	}

	/**
	 * @param args
	 *            the command line arguments
	 */
	public static void main(String args[]) {
		/* Set the Nimbus look and feel */
		// <editor-fold defaultstate="collapsed" desc=" Look and feel setting
		// code (optional) ">
		/*
		 * If Nimbus (introduced in Java SE 6) is not available, stay with the
		 * default look and feel. For details see
		 * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.
		 * html
		 */
		try {
			for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
				if ("Nimbus".equals(info.getName())) {
					javax.swing.UIManager.setLookAndFeel(info.getClassName());
					break;
				}
			}
		} catch (ClassNotFoundException ex) {
			java.util.logging.Logger.getLogger(Frame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (InstantiationException ex) {
			java.util.logging.Logger.getLogger(Frame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (IllegalAccessException ex) {
			java.util.logging.Logger.getLogger(Frame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (javax.swing.UnsupportedLookAndFeelException ex) {
			java.util.logging.Logger.getLogger(Frame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}
		// </editor-fold>

		/* Create and display the form */
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new Frame().setVisible(true);
			}
		});
	}

}
